//+------------------------------------------------------------------+
//|                                                  RSI_EMA_MTF.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Orange
#property indicator_width1 2
#property indicator_color4 White
#property strict

#property indicator_maximum 21
#property indicator_minimum-21
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_M5;             // Time frame
extern int             RsiPeriod        = 14;             // RSI period
extern ENUM_APPLIED_PRICE RsiPrice      = PRICE_CLOSE;    // RSI price
extern ENUM_MA_METHOD  MaType           = MODE_EMA;       // Average type
extern int             MaPeriod         = 50;             // Average period
extern bool            alertsOn         = false;           // Turn alerts on?
extern bool            alertsOnCurrent  = true;           // Alerts on a current bar?
extern bool            alertsMessage    = false;           // Alerts should display a message?
extern bool            alertsSound      = false;          // Alerts should play a sound?
extern bool            alertsEmail      = false;          // Alerts should send an email?
extern string          arrowsIdentifier = "RsiEmaArrows"; // Arrows identifier 
extern color           arrowsUpColor    = clrDeepSkyBlue; // Color for up arrow  
extern color           arrowsDnColor    = clrRed;         // Color for down arrow
extern double          arrowUpGap       = 0.5;            // Upper arrow gap
extern double          arrowDnGap       = 1.25;           // Lower arrow gap
extern bool            Interpolate      = true;           // Interpolate in multi time frame
extern double          LevUp       = 5.0;            
extern double          LevDn       = -5.0; 
extern int             SizeArrow        = 3;  

extern string _______________LevelUp____;

extern bool UPAlert=false;
extern bool SoundAlto=true;  

 //extern bool OnAlert2=true;  
 //extern bool OnAlert1=true;  
extern string _______________SET____AlertDOWN;

extern bool DOWNAlert=false;
extern bool SoundBasso=true;
extern string FileSoundUP = "alert.wav";
extern string FileSoundDOWN = "alert2.wav";
int PlayedSoundH = False;
int PlayedSoundL = False;
int PlayedSoundH2 = False;
int PlayedSoundL2 = False;


//
//
//
//
//


//
//
//
//
//

double rsi[],ema[],trend[];

string indicatorFileName;
bool   calculating   = false;
bool   returningBars = false;
double Range[];
int    timeFrame;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);      
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,ema);
   SetIndexBuffer(2,trend);
   SetIndexBuffer(3,Range);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,2);
      calculating       = TimeFrame==-98;
      returningBars     = TimeFrame==-99;
      timeFrame         = MathMax(TimeFrame,_Period);
      indicatorFileName = WindowExpertName();
   IndicatorShortName("MTF RSI "+tf());
   return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal(0,-1,OBJ_ARROW)-1; i>=0; i--)
   {
      string objectName = ObjectName(0,i,-1,OBJ_ARROW);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returningBars)  { rsi[0] = limit+1; return(0); }
            if (timeFrame != _Period) limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,-99,0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //

     if (calculating)
     {
         for(int i=limit; i>=0; i--) rsi[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
         for(int i=limit; i>=0; i--)
         {
            ema[i]   = iMAOnArray(rsi,0,MaPeriod,0,MaType,i);
            trend[i] = (rsi[i]>ema[i]) ? 1 : (rsi[i]<ema[i]) ? -1 : (i<Bars-1) ? trend[i+1] : 0;
         }               
         if (alertsOn)
         {
            int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
            if (trend[whichBar] != trend[whichBar+1])
            {
               if (trend[whichBar] == 1) doAlert("up");
               if (trend[whichBar] ==-1) doAlert("down");
            }         
         }
         return(0);
     }         
     for(int i=limit; i>=0; i--)
     {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            rsi[i]   = iCustom(NULL,timeFrame,indicatorFileName,-98,RsiPeriod,RsiPrice,MaType,MaPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
            ema[i]   = iCustom(NULL,timeFrame,indicatorFileName,-98,RsiPeriod,RsiPrice,MaType,MaPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,-98,RsiPeriod,RsiPrice,MaType,MaPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
            
            //
            //
            //
            //
            
                
               
            
            
            Range[i] = ((rsi[i]-ema[i]));

               ObjectDelete(arrowsIdentifier+":"+(string)Time[i]);
               if (i<Bars-1 && Range[i] != Range[i+1])
               {
                  if (//trend[i] == 1&&
                  Range[i]>LevUp&&Range[i+1]<LevUp) drawArrow(i,arrowsUpColor,241,arrowUpGap,false);
                  if (//trend[i] ==-1&&
                  Range[i]<LevDn&&Range[i+1]>LevDn) drawArrow(i,arrowsDnColor,242,arrowDnGap,true);
               }
                 // Range[i] = ((rsi[i]-ema[i]));
               //
               //
               //
               //
               //
                           
               if (timeFrame <= _Period || !Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
               //
               //
               //
               //
               //
                  
               #define _interpolate(buff,i,k,n) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++)
                     {
                        _interpolate(rsi,i,k,n);
                        _interpolate(ema,i,k,n);
                     }  
                     
                    if(  Range[0]<LevUp
  
        ){PlayedSoundH2 = False;}
   
       if( Range[0]>LevDn ){PlayedSoundL2 = False;} 
      
      
       if(   Range[0]>LevUp
       &&Range[1]<LevUp
    // &&  Range[0]< 147483647
       && PlayedSoundH2 == False
        ){
       if(UPAlert)Alert(Symbol(), " (", Period(), "FastTMALine-Bull " , Range[0]  , "| Range |" , Range[1], " RageS |",   " Rsi |", " PIPS |");
     
       if (SoundAlto) PlaySound(FileSoundUP);
       PlayedSoundH2 = True;}
         
         
       if( Range[0]<LevDn
       &&Range[1]>LevDn
        //&&  Range[0]< 147483647
       && PlayedSoundL2 == False){
       if(DOWNAlert)Alert(Symbol(), " (", Period(), "FastTMALine-Bear" ,  Range[0], "| Range |" ,Range[1], "RangeS |",   " Rsi |");
       if (SoundBasso) PlaySound(FileSoundDOWN);
       PlayedSoundL2 = True;}    
                         
                 
                     
                                           
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode, double gap, bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
          gap *= iATR(NULL,0,10,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      ObjectSet(name,OBJPROP_WIDTH,SizeArrow);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," RSI crossed EMA ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"RsiEma"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string tf()
{
   switch(timeFrame)
   {
      case PERIOD_M1:  return("M(1)");
      case PERIOD_M5:  return("M(5)");
      case PERIOD_M15: return("M(15)");
      case PERIOD_M30: return("M(30)");
      case PERIOD_H1:  return("H(1)");
      case PERIOD_H4:  return("H(4)");
      case PERIOD_D1:  return("D(1)");
      case PERIOD_W1:  return("W(1)");
      case PERIOD_MN1: return("MN(1)");
      default:         return("Unknown timeframe");
   }
}